How to add variation animation in EJ2 JavaScript Sidebar

21 Aug 202616 minutes to read

In the following example, the Sidebar is rendered with custom animation effects. Click the buttons available in the main content area to observe how the custom animations work with the Sidebar.

The Sidebar will automatically adjust its expanding animation to match any custom size specified in CSS styles.

ej.base.enableRipple(true);

//initialization of sidebar 
var sidebarElement = new ej.navigations.Sidebar({
    showBackdrop: true, width: '280px', created: oncreate
});
sidebarElement.appendTo('#sidebar-element');
//end of Sidebar initialization
document.getElementById('zoom').onclick = function () {
    sidebarElement.show();
    sidebarElement.element.classList.add("w3-animate-zoom");
}
// Opendoor Effect
document.getElementById('open_door').onclick = function () {
    sidebarElement.show();
    var sidebar = document.getElementsByClassName("e-sidebar-overlay")[0];
    sidebar.classList.add("move");
}
//Bottom to Top
document.getElementById('bottom_top').onclick = function () {
    sidebarElement.show();
    sidebarElement.element.classList.add("w3-animate-bottom");
}
//Rotate Sidebar 
document.getElementById('rotate').onclick = function () {
    sidebarElement.show();
    sidebarElement.element.classList.add("rotate");
}
//Rotate 3d Animation
document.getElementById('rotate_3d').onclick = function () {
    sidebarElement.show();
    sidebarElement.element.classList.add("rotate_3d");
}
//Reverse Slide Out
document.getElementById('reverse').onclick = function () {
    sidebarElement.show();
    sidebarElement.element.classList.add("reverse_slide_out");
}

// Close the Sidebar
document.getElementById('close_btn').onclick = function () {
    sidebarElement.element.classList.remove("sidebar");
    sidebarElement.element.classList.remove("rotate");
    sidebarElement.element.classList.remove("w3-animate-zoom");
    sidebarElement.element.classList.remove("w3-animate-bottom");
    sidebarElement.element.classList.remove("rotate_3d");
    sidebarElement.element.classList.remove("reverse_slide_out");
    sidebarElement.hide();
};

function oncreate() {
    this.element.style.visibility = '';
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 Sidebar</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0-beta.3/css/bootstrap.min.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="styles.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div>
        <aside id="sidebar-element" class="sidebar" style="visibility: hidden">
            <div class="title"> Sidebar content</div>
            <div class="sub-title">
                * Sidebar is rendered with animation effect
            </div>
            <div class="center-align">
                <button id="close_btn" class="e-btn close-btn">Close Sidebar</button>
            </div>
        </aside>
        <!-- end of Sidebar element -->
        <!-- main content declaration -->
        <div id="default">
            <div class="title">Sidebar Transitions</div>
            <div class="sub-title"> * Click the below button to render the Sidebar with animation effect.</div>
            <div style="padding:20px" class="center-align">
                <button id="zoom" class="e-btn e-info">Zoom Sidebar</button>
                <button id="open_door" class="e-btn e-info">Open Door </button>
                <button id="bottom_top" class="e-btn e-info">Bottom to Top</button>
            </div>
            <div style="padding:20px" class="center-align">
                <button id="rotate" class="e-btn e-info"> Rotate</button>
                <button id="rotate_3d" class="e-btn e-info"> Rotate 3D</button>
                <button id="reverse" class="e-btn e-info"> Reverse Slide Out</button>
            </div>
        </div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
    <style>
        /*Sidebar element styles*/
        #sidebar-element {
            background-color: rgb(25, 118, 210);
            color: #ffffff;
        }

        .sidebar {
            animation-name: rotate_sidebar;
            animation-duration: 2s
        }

        @keyframes rotate_sidebar {
            from {
                transform: rotateY(150deg)
            }

            to {
                transform: rotateY(360deg)
            }
        }

        /*main content styles*/
        .title {
            text-align: center;
            font-size: 25px;
            padding: 15px;
            font-style: italic;
        }

        .sub-title {
            text-align: center;
            font-size: 16px;
            padding: 10px;
            font-style: italic;
        }

        .center-align {
            text-align: center;
        }

        /*Animation styles*/
        .move {
            transform: rotateX(-20deg);
        }

        #close,
        #close:hover,
        #close:active,
        #close:focus {
            /* csslint allow: adjoining-classes*/
            background: #fafafa;
            color: black;
        }

        #close_btn,
        #close_btn:hover,
        #close_btn:active,
        #close_btn:focus {
            /* csslint allow: adjoining-classes*/
            background: #fafafa;
            color: black;
        }

        .w3-animate-bottom {
            animation-name: animatebottom;
            animation-duration: 1s;
        }

        @keyframes animatebottom {
            from {
                margin-top: 100%;
            }

            to {
                margin-top: 0%;
            }
        }

        .w3-animate-zoom {
            animation-name: animatezoom;
            animation-duration: 1s
        }

        @keyframes animatezoom {
            from {
                transform: scale(0)
            }

            to {
                transform: scale(1)
            }
        }

        .rotate {
            animation-name: rotate1;
            animation-duration: 1s
        }

        @keyframes rotate1 {
            from {
                transform: rotateX(150deg)
            }

            to {
                transform: rotateX(360deg)
            }
        }

        .rotate_3d {
            animation-name: rotate;
            animation-duration: 1s
        }

        @keyframes rotate {
            from {
                transform: rotateY(150deg)
            }

            to {
                transform: rotateY(360deg)
            }
        }

        .reverse_slide_out {

            animation-name: reverse1;
            animation-duration: 1s
        }

        @keyframes reverse1 {
            from {
                transform: rotateY(-65deg);
                margin-left: 200px;
            }

            to {
                margin-left: 0%;
            }
        }

        /*End of animation styles*/
    </style>
</body>

</html>
#container {
  visibility: hidden;
}

#loader {
  color: #008cff;
  height: 40px;
  width: 30%;
  position: absolute;
  top: 45%;
  left: 45%;
}

How to use custom animation in Sidebar in React

In the following example, the Sidebar is rendered with custom animation effects. Click the buttons available in the main content area to check how the custom animations works with sidebar.

Sidebar will automatically adjust expanding animation to match any custom size specified in CSS styles.

import * as React from 'react';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { SidebarComponent } from '@syncfusion/ej2-react-navigations';

function App() {
    let sidebarObj;
    let btnObj;
    let showBackdrop = true;
    function onCreate() {
        sidebarObj.element.style.visibility = '';
    }
    // Zoom Sidebar
    function zoom() {
        sidebarObj.show();
        sidebarObj.element.classList.add("w3-animate-zoom");
    }
    // Open Door
    function open_door() {
        sidebarObj.show();
        const sidebar = document.getElementsByClassName("e-sidebar-overlay")[0];
        sidebar.classList.add("move");
    }
    // Bottom to Top
    function bottom_top() {
        sidebarObj.show();
        sidebarObj.element.classList.add("w3-animate-bottom");
    }
    // Rotate
    function rotate() {
        sidebarObj.show();
        sidebarObj.element.classList.add("rotate");
    }
    // Rotate 3D Effect
    function rotate_3d() {
        sidebarObj.show();
        sidebarObj.element.classList.add("rotate_3d");
    }
    // Reverse Slide Out
    function reverse() {
        sidebarObj.show();
        sidebarObj.element.classList.add("reverse_slide_out");
    }
    // Close Sidebar Element
    function close() {
        sidebarObj.element.classList.remove("sidebar");
        sidebarObj.element.classList.remove("rotate");
        sidebarObj.element.classList.remove("w3-animate-zoom");
        sidebarObj.element.classList.remove("w3-animate-bottom");
        sidebarObj.element.classList.remove("rotate_3d");
        sidebarObj.element.classList.remove("reverse_slide_out");
        sidebarObj.hide();
    }
    return (
    // Declaration of Sidebar Element
    <div className="control-section">
            <SidebarComponent id="sidebar-element" className="sidebar" ref={Sidebar => sidebarObj = Sidebar} showBackdrop={showBackdrop} style= created={onCreate} width="280px">
                <div className="title"> Sidebar content</div>
                    <div className="sub-title">
                        * Sidebar is rendered with animation effect
                    </div>
                    <div className="center-align">
                        {/* Close Button Declaration*/}
                        <ButtonComponent onClick={close} id="close" className="e-btn close-btn">Close Sidebar</ButtonComponent>
                    </div>
            </SidebarComponent>
            {/*End of Sidebar Element Declaration*/}
            {/* Main Content Declaration*/}
            <div className="content">
                <div className="title">Sidebar Transitions</div>
                <div className="sub-title"> * Click the below button to render the Sidebar with animation effect.</div>
                <div className="center-align">
                    {/*Button Declaaration */}
                    <ButtonComponent onClick={zoom} id="zoom" className="e-btn e-info">Zoom Sidebar</ButtonComponent>
                    <ButtonComponent onClick={open_door} id="open_door" className="e-btn e-info">Open Door</ButtonComponent>
                    <ButtonComponent onClick={bottom_top} id="bottom_top" className="e-btn e-info">Bottom to Top </ButtonComponent>
                </div>
                <div className="center-align">
                    <ButtonComponent onClick={rotate} id="rotate" className="e-btn e-info">Rotate</ButtonComponent>
                    <ButtonComponent onClick={rotate_3d} id="rotate_3d" className="e-btn e-info">Rotate 3D</ButtonComponent>
                    <ButtonComponent onClick={reverse} id="reverse" className="e-btn e-info">Reverse Slide Out </ButtonComponent>
                </div>
            </div>
        </div>);
}
export default App;
import * as React from 'react';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { SidebarComponent, SidebarType } from '@syncfusion/ej2-react-navigations';
import { enableRipple } from '@syncfusion/ej2-base';

function App() {
    let sidebarObj: SidebarComponent;
    let btnObj: ButtonComponent;
    let showBackdrop: boolean = true;
    function onCreate():void {
        sidebarObj.element.style.visibility='';
    }
    // Zoom Sidebar
    function zoom():void {
        sidebarObj.show();
        sidebarObj.element.classList.add("w3-animate-zoom");
    }
    // Open Door
    function open_door():void {
        sidebarObj.show();
        const sidebar: Element =document.getElementsByClassName("e-sidebar-overlay")[0];
        sidebar.classList.add("move");
    }
    // Bottom to Top
    function bottom_top(): void {
        sidebarObj.show();
        sidebarObj.element.classList.add("w3-animate-bottom");
    }
    // Rotate
    function rotate(): void {
        sidebarObj.show();
        sidebarObj.element.classList.add("rotate");
    }
    // Rotate 3D Effect
    function rotate_3d(): void {
        sidebarObj.show();
        sidebarObj.element.classList.add("rotate_3d");
    }
    // Reverse Slide Out
    function reverse(): void {
        sidebarObj.show();
        sidebarObj.element.classList.add("reverse_slide_out");
    }
    // Close Sidebar Element
    function close(): void {
        sidebarObj.element.classList.remove("sidebar");
        sidebarObj.element.classList.remove("rotate");
        sidebarObj.element.classList.remove("w3-animate-zoom");
        sidebarObj.element.classList.remove("w3-animate-bottom");
        sidebarObj.element.classList.remove("rotate_3d");
        sidebarObj.element.classList.remove("reverse_slide_out");
        sidebarObj.hide();
    }
    return (
        // Declaration of Sidebar Element
        <div className="control-section">
            <SidebarComponent id="sidebar-element" className="sidebar" ref={Sidebar => sidebarObj = Sidebar as SidebarComponent} showBackdrop={showBackdrop} style= created={onCreate} width="280px">
                <div className="title"> Sidebar content</div>
                    <div className="sub-title">
                        * Sidebar is rendered with animation effect
                    </div>
                    <div className="center-align">
                        {/* Close Button Declaration*/}
                        <ButtonComponent onClick={close} id="close" className="e-btn close-btn">Close Sidebar</ButtonComponent>
                    </div>
            </SidebarComponent>
            {/*End of Sidebar Element Declaration*/}
            {/* Main Content Declaration*/}
            <div className="content">
                <div className="title">Sidebar Transitions</div>
                <div className="sub-title"> * Click the below button to render the Sidebar with animation effect.</div>
                <div className="center-align">
                    {/*Button Declaaration */}
                    <ButtonComponent onClick={zoom} id="zoom" className="e-btn e-info">Zoom Sidebar</ButtonComponent>
                    <ButtonComponent onClick={open_door} id="open_door" className="e-btn e-info">Open Door</ButtonComponent>
                    <ButtonComponent onClick={bottom_top} id="bottom_top" className="e-btn e-info">Bottom to Top </ButtonComponent>
                </div>
                <div className="center-align">
                    <ButtonComponent onClick={rotate} id="rotate" className="e-btn e-info">Rotate</ButtonComponent>
                    <ButtonComponent onClick={rotate_3d} id="rotate_3d" className="e-btn e-info">Rotate 3D</ButtonComponent>
                    <ButtonComponent onClick={reverse} id="reverse" className="e-btn e-info">Reverse Slide Out </ButtonComponent>
                </div>
            </div>
        </div>
    )
}
export default App;
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import App from './App';
ReactDOM.render(<App />, document.getElementById('sample'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import App  from './App';

ReactDOM.render(<App />, document.getElementById('sample'));
/*Sidebar element styles*/
#sidebar-element {
	background-color: rgb(25, 118, 210);
    color: #ffffff;
}
.sidebar {
    animation-name:rotate_sidebar; 
    animation-duration: 2s
}
@keyframes rotate_sidebar{from{transform:rotateY(150deg)} to{transform:rotateY(360deg)}}
/*main content styles*/
.title {
	text-align: center;
	font-size: 25px;
    padding: 15px;
    font-style: italic;
}

.sub-title {
	text-align: center;
	font-size: 16px;
    padding: 10px;
    font-style: italic;
}

.center-align {
    text-align: center;
    padding-top: 20px;
}
/*Animation styles*/
.move {
    transform:rotateX(-20deg);
}
#close,#close:hover,#close:active,#close:focus{ /* csslint allow: adjoining-classes*/
	background: #fafafa;
	color:black;
}
.w3-animate-bottom {
    animation-name: animatebottom;
    animation-duration: 1s;
}
@keyframes animatebottom{from {
    margin-top: 100%;
  }
  to {
    margin-top: 0%;
  }}
  
  .w3-animate-zoom {animation-name:animatezoom; 
    animation-duration: 1s}
  @keyframes animatezoom{from{transform:scale(0)} to{transform:scale(1)}}

.rotate {
     animation-name:rotate1; 
    animation-duration: 1s
}
@keyframes rotate1{from{transform:rotateX(150deg)} to{transform:rotateX(360deg)}}
.rotate_3d {
    animation-name:rotate; 
   animation-duration: 1s
}
@keyframes rotate{from{transform:rotateY(150deg)} to{transform:rotateY(360deg)}}

  .reverse_slide_out  {
    
    animation-name: reverse1; 
    animation-duration: 1s
 }
 @keyframes reverse1  {from {
    transform: rotateY(-65deg);
    margin-left: 200px;
  }

  to {
    margin-left: 0%;
  }
}
/*End of animation styles*/
button {
    margin:5px;
}

How to add custom animation to Sidebar in Angular Sidebar

14 Aug 20267 minutes to read

The following example demonstrates the Sidebar rendered with custom animation effects. Click the buttons available in the main content area to check how the custom animations work with the Sidebar.

The Sidebar will automatically adjust its expanding animation to match any custom size specified in CSS styles.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { SidebarModule } from '@syncfusion/ej2-angular-navigations'




import { Component, ViewChild } from '@angular/core';
import { SidebarComponent } from '@syncfusion/ej2-angular-navigations';

@Component({
imports: [SidebarModule, ],


standalone: true,
    selector: 'app-root',
    styleUrls: ['./app.component.css'],
    template: ` <ejs-sidebar id="sidebar-element" class="sidebar" #sidebar  [showBackdrop]="showBackdrop" [closeOnDocumentClick]="closeOnDocumentClick" (created)="onCreated($event)" style="visibility: hidden">
                    <div class="title"> Sidebar content</div>
                    <div class="sub-title">
                        * Sidebar is rendered with animation effect
                    </div>
                    <div class="center-align">
                        <button ejs-button id="close_btn" (click)="closeClick_btn()" class="e-btn close-btn">Close Sidebar</button>
                    </div>
                </ejs-sidebar>
                <div>
                    <div class="title">Sidebar Transitions</div>
                    <div class="sub-title"> * Click the below button to render the Sidebar with animation effect.</div>
                    <div style="padding:20px" class="center-align">
                        <button ejs-button id="toggle" class="e-btn e-info" (click)="zoom()">Zoom Sidebar</button>
                        <button ejs-button id="toggle" class="e-btn e-info" (click)="open_door()">Open Door</button>
                        <button ejs-button id="toggle" class="e-btn e-info" (click)="bottom_top()">Bottom to Top</button>
                    </div>
                    <div style="padding:20px" class="center-align">
                        <button ejs-button id="toggle" class="e-btn e-info" (click)="rotate()">Rotate Sidebar</button>
                        <button ejs-button id="toggle" class="e-btn e-info" (click)="rotate_3d()">Rotate 3D</button>
                        <button ejs-button id="toggle" class="e-btn e-info" (click)="reverse()">Reverse Slide Out</button>
                    </div>
                </div>`
})
export class AppComponent {
  @ViewChild('sidebar') sidebar?: SidebarComponent;
  public showBackdrop: boolean = true;
  public closeOnDocumentClick: boolean = true;

  public onCreated(args: any) {
         (this.sidebar as SidebarComponent).element.style.visibility = '';
    }
  // Close Button
  closeClick_btn(): void {
    (this.sidebar as SidebarComponent).element.classList.remove("sidebar");
    (this.sidebar as SidebarComponent).element.classList.remove("rotate");
    (this.sidebar as SidebarComponent).element.classList.remove("w3-animate-zoom");
    (this.sidebar as SidebarComponent).element.classList.remove("w3-animate-bottom");
    (this.sidebar as SidebarComponent).element.classList.remove("rotate_3d");
    (this.sidebar as SidebarComponent).element.classList.remove("reverse_slide_out");
    this.sidebar?.hide();
  };
  // Zoom Effect
  zoom():void{
    this.sidebar?.show();
    (this.sidebar as SidebarComponent).element.classList.add("w3-animate-zoom");
  };
  // Open Door
  open_door():void{
    this.sidebar?.show();
    let sidebar_element: Element =document.getElementsByClassName("e-sidebar-overlay")[0];
    sidebar_element.classList.add("move");
    (document.getElementsByClassName("move")[0] as any).style.transform ="rotateX(-20deg)";
  };
  // Bottom To Top
  bottom_top():void{
    this.sidebar?.show();
    (this.sidebar as SidebarComponent).element.classList.add("w3-animate-bottom");
  };
  // Rotate
  rotate():void{
    this.sidebar?.show();
    (this.sidebar as SidebarComponent).element.classList.add("rotate");
  };
  // Rotate 3D
  rotate_3d():void{
    this.sidebar?.show();
    (this.sidebar as SidebarComponent).element.classList.add("rotate_3d");
  };
  // Reverse Slide Out
  reverse():void{
    this.sidebar?.show();
    (this.sidebar as SidebarComponent).element.classList.add("reverse_slide_out");
  };
}
@import 'node_modules/@syncfusion/ej2-base/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-base/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-navigations/styles/material3.css';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

How to render Sidebar with custom animation in Vue Sidebar

21 Aug 202621 minutes to read

In the following example, the Sidebar is rendered with custom animation effects. Click the buttons available in the main content area to check how the custom animations work with the Sidebar.

The Sidebar will automatically adjust its expanding animation to match any custom size specified in CSS styles.

<template>
  <div id="app">
    <div class="col-lg-8 control-section">
      <!-- Declaration of sidebar element-->
      <ejs-sidebar id="sidebar-element" class="sidebar" :showBackdrop="showBackdrop"
        :closeOnDocumentClick="closeOnDocumentClick" ref="sidebar" :width="width">
        <div class="title"> Sidebar content</div>
        <div class="sub-title">
          * Sidebar is rendered with animation effect
        </div>
        <div class="center-align">
          <!-- Declaration of button element-->
          <button ejs-button id="close_btn" v-on:click="closeClick_btn" class="e-btn close-btn">Close Sidebar</button>
        </div>
      </ejs-sidebar>
      <!-- End of sidebar element-->
    </div>
    <div class="content">
      <div class="title">Sidebar Transitions</div>
      <div class="sub-title"> * Click the below button to render the Sidebar with animation effect.</div>
      <div class="center-align">
        <!-- Declaration of button element-->
        <button ejs-button id="zoom" v-on:click="zoom" class="e-btn e-info">Zoom Sidebar</button>
        <button ejs-button id="open_door" v-on:click="open_door" class="e-btn e-info">Open Door</button>
        <button ejs-button id="bottom_top" v-on:click="bottom_top" class="e-btn e-info">Bottom to Top</button>
      </div>
      <div class="center-align">
        <!-- Declaration of button element-->
        <button ejs-button id="rotate" v-on:click="rotate" class="e-btn e-info">Rotate </button>
        <button ejs-button id="rotate_3d" v-on:click="rotate_3d" class="e-btn e-info">Rotate 3D </button>
        <button ejs-button id="reverse" v-on:click="reverse" class="e-btn e-info">Reverse Slide Out </button>
      </div>
    </div>
  </div>
</template>

<script setup>

  import { SidebarComponent as EjsSidebar } from '@syncfusion/ej2-vue-navigations';
  import { ref } from 'vue';

  const sidebar = ref(null);
  const showBackdrop = true;
  const closeOnDocumentClick = true;
  const width = '220px';

  // Zoom Sidebar
  const zoom = () => {
    sidebar.value.show();
    sidebar.value.$el.classList.add("w3-animate-zoom");
  };
  // Open Door
  const open_door = () => {
    sidebar.value.show();
    const sidebar_element = document.getElementsByClassName("e-sidebar-overlay")[0];
    sidebar_element.classList.add("move");
  };
  // Bottom to Top
  const bottom_top = () => {
    sidebar.value.show();
    sidebar.value.$el.classList.add("w3-animate-bottom");
  };
  // Rotate Sidebar
  const rotate = () => {
    sidebar.value.show();
    sidebar.value.$el.classList.add("rotate");
  };
  // Rotate 3d Effect
  const rotate_3d = () => {
    sidebar.value.show();
    sidebar.value.$el.classList.add("rotate_3d");
  };
  // Reverse Slide Out
  const reverse = () => {
    sidebar.value.show();
    sidebar.value.$el.classList.add("reverse_slide_out");
  };
  //Close the sidebar
  const closeClick_btn = () => {
    sidebar.value.$el.classList.remove("sidebar");
    sidebar.value.$el.classList.remove("rotate");
    sidebar.value.$el.classList.remove("w3-animate-zoom");
    sidebar.value.$el.classList.remove("w3-animate-bottom");
    sidebar.value.$el.classList.remove("rotate_3d");
    sidebar.value.$el.classList.remove("reverse_slide_out");
    sidebar.value.hide();
  };

</script>

<style>
  @import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-base/styles/material.css";

  /*Sidebar element styles*/
  #sidebar-element {
    background-color: rgb(25, 118, 210);
    color: #ffffff;
  }

  .sidebar {
    animation-name: rotate_sidebar;
    animation-duration: 2s
  }

  @keyframes rotate_sidebar {
    from {
      transform: rotateY(150deg)
    }

    to {
      transform: rotateY(360deg)
    }
  }

  /*main content styles*/
  .title {
    text-align: center;
    font-size: 25px;
    padding: 15px;
    font-style: italic;
  }

  .sub-title {
    text-align: center;
    font-size: 16px;
    padding: 10px;
    font-style: italic;
  }

  .center-align {
    text-align: center;
    padding-top: 20px;
  }

  /*Animation styles*/
  .move {
    transform: rotateX(-20deg);
  }

  #close,
  #close:hover,
  #close:active,
  #close:focus {
    /* csslint allow: adjoining-classes*/
    background: #fafafa;
    color: black;
  }

  #close_btn,
  #close_btn:hover,
  #close_btn:active,
  #close_btn:focus {
    /* csslint allow: adjoining-classes*/
    background: #fafafa;
    color: black;
  }

  .w3-animate-bottom {
    animation-name: animatebottom;
    animation-duration: 1s;
  }

  @keyframes animatebottom {
    from {
      margin-top: 100%;
    }

    to {
      margin-top: 0%;
    }
  }

  .w3-animate-zoom {
    animation-name: animatezoom;
    animation-duration: 1s
  }

  @keyframes animatezoom {
    from {
      transform: scale(0)
    }

    to {
      transform: scale(1)
    }
  }

  .rotate {
    animation-name: rotate1;
    animation-duration: 1s
  }

  @keyframes rotate1 {
    from {
      transform: rotateX(150deg)
    }

    to {
      transform: rotateX(360deg)
    }
  }

  .rotate_3d {
    animation-name: rotate;
    animation-duration: 1s
  }

  @keyframes rotate {
    from {
      transform: rotateY(150deg)
    }

    to {
      transform: rotateY(360deg)
    }
  }

  .reverse_slide_out {
    animation-name: reverse1;
    animation-duration: 1s
  }

  @keyframes reverse1 {
    from {
      transform: rotateY(-65deg);
      margin-left: 200px;
    }

    to {
      margin-left: 0%;
    }
  }

  /*End of animation styles*/
  button {
    margin: 5px;
  }
</style>
<template>
  <div id="app">
    <div class="col-lg-8 control-section">
      <!-- Declaration of sidebar element-->
      <ejs-sidebar id="sidebar-element" class="sidebar" :showBackdrop="showBackdrop"
        :closeOnDocumentClick="closeOnDocumentClick" ref="sidebar" :width="width">
        <div class="title"> Sidebar content</div>
        <div class="sub-title">
          * Sidebar is rendered with animation effect
        </div>
        <div class="center-align">
          <!-- Declaration of button element-->
          <button ejs-button id="close_btn" v-on:click="closeClick_btn" class="e-btn close-btn">Close Sidebar</button>
        </div>
      </ejs-sidebar>
      <!-- End of sidebar element-->
    </div>
    <div class="content">
      <div class="title">Sidebar Transitions</div>
      <div class="sub-title"> * Click the below button to render the Sidebar with animation effect.</div>
      <div class="center-align">
        <!-- Declaration of button element-->
        <button ejs-button id="zoom" v-on:click="zoom" class="e-btn e-info">Zoom Sidebar</button>
        <button ejs-button id="open_door" v-on:click="open_door" class="e-btn e-info">Open Door</button>
        <button ejs-button id="bottom_top" v-on:click="bottom_top" class="e-btn e-info">Bottom to Top</button>
      </div>
      <div class="center-align">
        <!-- Declaration of button element-->
        <button ejs-button id="rotate" v-on:click="rotate" class="e-btn e-info">Rotate </button>
        <button ejs-button id="rotate_3d" v-on:click="rotate_3d" class="e-btn e-info">Rotate 3D </button>
        <button ejs-button id="reverse" v-on:click="reverse" class="e-btn e-info">Reverse Slide Out </button>
      </div>
    </div>
  </div>
</template>

<script>

  import { SidebarComponent } from '@syncfusion/ej2-vue-navigations';

  export default {
    name: "App",
    components: {
      "ejs-sidebar": SidebarComponent
    },
    data() {
      return {
        showBackdrop: true,
        closeOnDocumentClick: true,
        width: '220px',
      };
    },
    methods: {
      // Zoom Sidebar
      zoom: function () {
        this.$refs.sidebar.show();
        this.$refs.sidebar.$el.classList.add("w3-animate-zoom");
      },
      // Open Door
      open_door: function () {
        this.$refs.sidebar.show();
        const sidebar_element = document.getElementsByClassName("e-sidebar-overlay")[0];
        sidebar_element.classList.add("move");
      },
      // Bottom to Top
      bottom_top: function () {
        this.$refs.sidebar.show();
        this.$refs.sidebar.$el.classList.add("w3-animate-bottom");
      },
      // Rotate Sidebar
      rotate: function () {
        this.$refs.sidebar.show();
        this.$refs.sidebar.$el.classList.add("rotate");
      },
      // Rotate 3d Effect
      rotate_3d: function () {
        this.$refs.sidebar.show();
        this.$refs.sidebar.$el.classList.add("rotate_3d");
      },
      // Reverse Slide Out
      reverse: function () {
        this.$refs.sidebar.show();
        this.$refs.sidebar.$el.classList.add("reverse_slide_out");
      },
      //Close the sidebar
      closeClick_btn: function () {
        this.$refs.sidebar.$el.classList.remove("sidebar");
        this.$refs.sidebar.$el.classList.remove("rotate");
        this.$refs.sidebar.$el.classList.remove("w3-animate-zoom");
        this.$refs.sidebar.$el.classList.remove("w3-animate-bottom");
        this.$refs.sidebar.$el.classList.remove("rotate_3d");
        this.$refs.sidebar.$el.classList.remove("reverse_slide_out");
        this.$refs.sidebar.hide();
      }
    }
  }

</script>

<style>
  @import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-base/styles/material.css";

  /*Sidebar element styles*/
  #sidebar-element {
    background-color: rgb(25, 118, 210);
    color: #ffffff;
  }

  .sidebar {
    animation-name: rotate_sidebar;
    animation-duration: 2s
  }

  @keyframes rotate_sidebar {
    from {
      transform: rotateY(150deg)
    }

    to {
      transform: rotateY(360deg)
    }
  }

  /*main content styles*/
  .title {
    text-align: center;
    font-size: 25px;
    padding: 15px;
    font-style: italic;
  }

  .sub-title {
    text-align: center;
    font-size: 16px;
    padding: 10px;
    font-style: italic;
  }

  .center-align {
    text-align: center;
    padding-top: 20px;
  }

  /*Animation styles*/
  .move {
    transform: rotateX(-20deg);
  }

  #close,
  #close:hover,
  #close:active,
  #close:focus {
    /* csslint allow: adjoining-classes*/
    background: #fafafa;
    color: black;
  }

  #close_btn,
  #close_btn:hover,
  #close_btn:active,
  #close_btn:focus {
    /* csslint allow: adjoining-classes*/
    background: #fafafa;
    color: black;
  }

  .w3-animate-bottom {
    animation-name: animatebottom;
    animation-duration: 1s;
  }

  @keyframes animatebottom {
    from {
      margin-top: 100%;
    }

    to {
      margin-top: 0%;
    }
  }

  .w3-animate-zoom {
    animation-name: animatezoom;
    animation-duration: 1s
  }

  @keyframes animatezoom {
    from {
      transform: scale(0)
    }

    to {
      transform: scale(1)
    }
  }

  .rotate {
    animation-name: rotate1;
    animation-duration: 1s
  }

  @keyframes rotate1 {
    from {
      transform: rotateX(150deg)
    }

    to {
      transform: rotateX(360deg)
    }
  }

  .rotate_3d {
    animation-name: rotate;
    animation-duration: 1s
  }

  @keyframes rotate {
    from {
      transform: rotateY(150deg)
    }

    to {
      transform: rotateY(360deg)
    }
  }

  .reverse_slide_out {
    animation-name: reverse1;
    animation-duration: 1s
  }

  @keyframes reverse1 {
    from {
      transform: rotateY(-65deg);
      margin-left: 200px;
    }

    to {
      margin-left: 0%;
    }
  }

  /*End of animation styles*/
  button {
    margin: 5px;
  }
</style>